;-----------------------------------------------------------------------
; translucency for #32768 etc
;-----------------------------------------------------------------------

.386
.model flat,stdcall
option casemap:none

.const
  __UNICODE__  equ 1

include windows.inc
include c:\masm32\macros\macros.asm

inclib macro x
 include x.inc
 includelib x.lib
endm

inclib user32
inclib kernel32
inclib gdi32

.data
 _next  TCHAR 13,10,0
.data?
  hw1   HWND ?
  hw2   HWND ?
  hw3   HWND ?
  hwx   HWND ?
  hinst dd ?
  flg   dd ?  
.code

;-----------------------------------------------------------------------

WriteStringToFile proc uses ebx lpString:DWORD,lpFileName:DWORD

  local	bytes:DWORD
  local buf[MAX_PATH]:TCHAR

  invoke CreateFile,lpFileName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ or FILE_SHARE_WRITE,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
  .if eax!=INVALID_HANDLE_VALUE
    mov ebx,eax
    invoke SetFilePointer,ebx,0,0,FILE_END
    invoke lstrcpy,addr buf,lpString
    invoke lstrcat,addr buf,offset _next
    invoke lstrlen,addr buf
    mov edx,sizeof TCHAR
    .if edx==2
      add eax,eax
    .endif
    mov bytes,eax
    invoke WriteFile,ebx,addr buf,bytes,addr bytes,0
    invoke CloseHandle,ebx
  .endif
  ret
WriteStringToFile endp

;-----------------------------------------------------------------------

OnTimer proc uses ebx edi esi

;; local dcorgx:POINT  
  local pt:POINT
  local rt:RECT
  local rc:RECT
  local rct:RECT
  local buf[MAX_PATH]:TCHAR
  local buf1[MAX_PATH]:TCHAR  
  local buf2[MAX_PATH]:TCHAR
  local buff[1024]:TCHAR
  local buff1[1024]:TCHAR
  local bu[10]:TCHAR  
  local var:DWORD
  local lay:DWORD
  local pup:DWORD
  local cap:DWORD
  local hwdc:DWORD
  local rtvis:DWORD

;;	 invoke GetDCOrgEx,hwdc,addr dcorgx

  xor eax,eax
  mov lay,eax
  mov pup,eax
  mov cap,eax

  invoke SetWindowPos,hw1,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
  invoke GetCursorPos,addr pt
  invoke WindowFromPoint,pt.x,pt.y
  mov ebx,eax 

  invoke GetWindowRect,ebx,addr rt
  invoke GetClassName,ebx,addr buf,MAX_PATH
  invoke SendMessageTimeout,ebx,WM_GETTEXT,64,addr buf1,SMTO_ABORTIFHUNG,300,addr var
  invoke GetWindowText,ebx,addr buf2,64
  
  fn lstrcpy,addr bu,"---------"

  invoke GetWindowLong,ebx,GWL_EXSTYLE
  test eax,WS_EX_COMPOSITED
  jz @f
  mov TCHAR ptr[bu],'!'
@@:
  test eax,WS_EX_LAYERED
  jz @f
  mov TCHAR ptr[bu+1*(sizeof TCHAR)],'L'
@@:
  test eax,WS_EX_TRANSPARENT
  jz @f
  mov TCHAR ptr[bu+2*(sizeof TCHAR)],'T'
@@:
  test eax,WS_EX_TOOLWINDOW
  jz @f
  mov TCHAR ptr[bu+3*(sizeof TCHAR)],'t'
@@:
  invoke GetWindowLong,ebx,GWL_STYLE
  test eax,WS_POPUP
  jz @f
  mov TCHAR ptr[bu+4*(sizeof TCHAR)],'P'
@@:
  test eax,WS_CHILD
  jz @f
  mov TCHAR ptr[bu+5*(sizeof TCHAR)],'C'
@@:
  test eax,WS_BORDER   ; WS_CAPTION
  jz @f
  test eax,WS_DLGFRAME
  jz @f
  mov TCHAR ptr[bu+6*(sizeof TCHAR)],'c'
@@:
  test eax,WS_DISABLED
  jz @f
  mov TCHAR ptr[bu+7*(sizeof TCHAR)],'D'
@@:
  invoke IsWindowUnicode,ebx
  test eax,eax
  jz @f
  mov TCHAR ptr[bu+8*(sizeof TCHAR)],'U'
@@:

  invoke GetWindowDC,ebx
  mov hwdc,eax
  mov rct.left,0
  mov rct.top,0
  mov eax,rt.right
  sub eax,rt.left
  mov rct.right,eax
  mov eax,rt.bottom
  sub eax,rt.top
  mov rct.bottom,eax
  invoke RectVisible,hwdc,addr rct
  mov rtvis,eax
  invoke ReleaseDC,ebx,hwdc

  mov ecx,rt.right
  sub ecx,rt.left
  mov edx,rt.bottom
  sub edx,rt.top

  fn wsprintf,addr buff," hwnd:%9.8lX (%d) %s  [%d,%d, %d*%d]  '%s' - '%s' - '%s'",ebx,rtvis,addr bu,rt.left,rt.top,ecx,edx,addr buf,addr buf1,addr buf2

  .if flg!=0
    mov TCHAR ptr[buff],'-'
  .else
    mov TCHAR ptr[buff],' '
  .endif
  
  invoke SendMessage,hw1,LB_GETTEXT,0,addr buff1
  invoke lstrcmp,addr buff,addr buff1
  test eax,eax
  jz @f
  invoke SendMessage,hw1,LB_DELETESTRING,0,0
  invoke SendMessage,hw1,LB_INSERTSTRING,0,addr buff
@@:

  invoke GetAncestor,ebx,GA_ROOT
  mov esi,eax
  invoke GetWindowRect,esi,addr rc
  invoke GetClassName,esi,addr buf2,MAX_PATH
  invoke SendMessageTimeout,esi,WM_GETTEXT,64,addr buf1,SMTO_ABORTIFHUNG,300,addr var

  fn lstrcpy,addr bu,"---------"
  
  invoke GetWindowLong,esi,GWL_EXSTYLE
  test eax,WS_EX_COMPOSITED
  jz @f
  mov TCHAR ptr[bu],'!'
@@:
  test eax,WS_EX_LAYERED
  jz @f
  inc lay
  mov TCHAR ptr[bu+1*(sizeof TCHAR)],'L'
@@:
  test eax,WS_EX_TRANSPARENT
  jz @f
  mov TCHAR ptr[bu+2*(sizeof TCHAR)],'T'
@@:
  test eax,WS_EX_TOOLWINDOW
  jz @f
  mov TCHAR ptr[bu+3*(sizeof TCHAR)],'t'
@@:
  invoke GetWindowLong,esi,GWL_STYLE
  test eax,WS_POPUP
  jz @f
  inc pup
  mov TCHAR ptr[bu+4*(sizeof TCHAR)],'P'
@@:
  test eax,WS_CHILD
  jz @f
  mov TCHAR ptr[bu+5*(sizeof TCHAR)],'C'
@@:
  test eax,WS_BORDER   ; WS_CAPTION
  jz @f
  test eax,WS_DLGFRAME
  jz @f
  inc cap
  mov TCHAR ptr[bu+6*(sizeof TCHAR)],'c'
@@:
  test eax,WS_DISABLED
  jz @f
  mov TCHAR ptr[bu+7*(sizeof TCHAR)],'D'
@@:
  invoke IsWindowUnicode,esi
  test eax,eax
  jz @f
  mov TCHAR ptr[bu+8*(sizeof TCHAR)],'U'
@@:

  invoke GetWindowDC,esi
  mov hwdc,eax
  mov rct.left,0
  mov rct.top,0
  mov eax,rc.right
  sub eax,rc.left
  mov rct.right,eax
  mov eax,rc.bottom
  sub eax,rc.top
  mov rct.bottom,eax
  invoke RectVisible,hwdc,addr rct
  mov rtvis,eax
  invoke ReleaseDC,esi,hwdc

  mov ecx,rc.right
  sub ecx,rc.left
  mov edx,rc.bottom
  sub edx,rc.top  

  fn wsprintf,addr buff," root:%9.8lX (%d) %s  [%d,%d, %d*%d]  '%s' - '%s'",esi,rtvis,addr bu,rc.left,rc.top,ecx,edx,addr buf2,addr buf1

  .if flg!=0
    mov TCHAR ptr[buff],'-'
  .else
    mov TCHAR ptr[buff],' '
  .endif

  invoke SendMessage,hw1,LB_GETTEXT,1,addr buff1
  invoke lstrcmp,addr buff,addr buff1
  test eax,eax
  jz @f
  invoke SendMessage,hw1,LB_DELETESTRING,1,0
  invoke SendMessage,hw1,LB_INSERTSTRING,1,addr buff
@@:
  .if (lay==0 || (lay!=0 && rtvis==1)) && pup!=0 && cap==0 && esi!=hw1 && esi!=hw2 && esi!=hw3
    mov edi,100
    .while TRUE
      invoke LoadString,hinst,edi,addr buf1,MAX_PATH
    .break .if eax==0
      invoke lstrcmpi,addr buf1,addr buf2
      jz @f
      inc edi
    .endw
    mov edx,6
    mov ecx,rt.left
    sub ecx,rc.left
    .if ecx>=0 && ecx<edx
      mov ecx,rt.top
      sub ecx,rc.top
      .if ecx>=0 && ecx<edx
        mov ecx,rc.right
        sub ecx,rt.right
        .if ecx>=0 && ecx<edx
          mov ecx,rc.bottom
          sub ecx,rt.bottom
          .if ecx>=0 && ecx<edx
            .if flg==0
              invoke GetWindowLong,esi,GWL_EXSTYLE
              or eax,WS_EX_LAYERED
              invoke SetWindowLong,esi,GWL_EXSTYLE,eax
              invoke SetWindowPos,esi,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
              invoke GetWindowLong,esi,GWL_EXSTYLE
              and eax,WS_EX_LAYERED
              .if eax==0
                .if ebx!=hwx
                  mov hwx,ebx
                  invoke Beep,300,300
                .endif
                jmp @f
              .endif
              invoke SetLayeredWindowAttributes,esi,0,180,LWA_ALPHA
              invoke SetWindowPos,esi,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED

              xor edi,edi
              .if ebx==esi
                invoke SendMessage,hw3,LB_FINDSTRINGEXACT,-1,addr buf
                .if eax==LB_ERR
                  invoke SendMessage,hw3,LB_ADDSTRING,0,addr buf
                  lea edi,buf
                .endif
              .else
                fn wsprintf,addr buff,"'%s' /root: '%s'",addr buf,addr buf2
                invoke SendMessage,hw3,LB_FINDSTRINGEXACT,-1,addr buff
                .if eax==LB_ERR
                  invoke SendMessage,hw3,LB_ADDSTRING,0,addr buff
                  lea edi,buff
                .endif
              .endif
              .if edi!=0
                invoke LoadString,hinst,200,addr buf1,MAX_PATH
                invoke WriteStringToFile,edi,addr buf1
              .endif
            .endif
          .endif
        .endif
      .endif    
    .endif
@@:
  .endif
  ret
OnTimer endp

;-----------------------------------------------------------------------

SubClass proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local rt:RECT

  .if uMsg==WM_LBUTTONDOWN            ; drag
    mov uMsg,WM_SYSCOMMAND
    mov wParam,SC_SIZE+9
    jmp @f
  .elseif uMsg==WM_RBUTTONDOWN        ; width
    mov uMsg,WM_SYSCOMMAND
    mov wParam,SC_SIZE+2
    jmp @f
  .elseif uMsg==WM_LBUTTONDBLCLK      ; 0-pos
    invoke GetWindowRect,hWnd,addr rt
    mov edx,rt.bottom
    sub edx,rt.top
    mov eax,2
    invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,eax,edx,SWP_FRAMECHANGED
    jmp @f
  .elseif uMsg==WM_MBUTTONDOWN         ; flg
    xor flg,1
    jmp @f
  .elseif uMsg==WM_NCHITTEST
@@:
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
  .elseif uMsg==WM_SETFOCUS
  .else
    invoke GetWindowLong,hWnd,GWL_USERDATA
    invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  .endif
  ret
SubClass endp
   
;-----------------------------------------------------------------------

EnumThreadWndProc proc uses ebx hWnd:HWND,lParam:LPARAM

  local buf[MAX_PATH]:TCHAR
  
  mov ebx,hWnd
  invoke GetClassName,ebx,addr buf,MAX_PATH
  fn lstrcmpi,addr buf,"LISTBOX"
  .if eax==0
    invoke GetWindowText,ebx,addr buf,MAX_PATH
    fn lstrcmpi,addr buf,"1"
    test eax,eax
    jnz @f
    mov hw1,ebx
@@:
    fn lstrcmpi,addr buf,"2"
    test eax,eax
    jnz @f
    mov hw2,ebx
@@:
    fn lstrcmpi,addr buf,"3"
    test eax,eax
    jnz @f
    mov hw3,ebx
@@:
  .endif
  xor eax,eax
  inc eax
  ret
EnumThreadWndProc endp
   
;-----------------------------------------------------------------------

DlgProc proc uses ebx edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local buf[MAX_PATH]:TCHAR

  .if uMsg==WM_CLOSE
@@:
    invoke KillTimer,hWnd,1
    invoke Beep,4000,200
    invoke Sleep,10
    invoke Beep,4000,200
    invoke EndDialog,hWnd,0

  .elseif uMsg==WM_TIMER && wParam==1
    invoke GetAsyncKeyState,VK_LBUTTON
    test eax,8000h
    jz @f
    invoke GetAsyncKeyState,VK_RBUTTON
    test eax,8000h
    jnz @b
@@:
    invoke GetAsyncKeyState,VK_MBUTTON
    test eax,8000h
    jz @@@
@@:    
    invoke Sleep,10
    invoke GetAsyncKeyState,VK_MBUTTON
    test eax,8000h
    jnz @b
    invoke IsWindowVisible,hw2
    .if eax==0
      invoke SetTimer,hWnd,2,3000,0
      mov edi,SWP_SHOWWINDOW or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
    .else
      invoke KillTimer,hWnd,2
      mov edi,SWP_HIDEWINDOW or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
    .endif
    invoke SetWindowPos,hw2,HWND_TOPMOST,0,0,0,0,edi
    invoke SetWindowPos,hw3,HWND_TOPMOST,0,0,0,0,edi    
@@@:
    invoke OnTimer

  .elseif uMsg==WM_TIMER && wParam==2
    invoke ShowWindow,hw2,SW_HIDE
    invoke ShowWindow,hw3,SW_HIDE
    invoke KillTimer,hWnd,2

  .elseif uMsg==WM_INITDIALOG
;    invoke GetLastActivePopup,hWnd
;    invoke GetWindow,hWnd,GW_ENABLEDPOPUP
;    mov hw1,eax
    invoke GetCurrentThreadId
    invoke EnumThreadWindows,eax,offset EnumThreadWndProc,0
    xor edi,edi
    .while TRUE
      invoke LoadString,hinst,edi,addr buf,MAX_PATH
    .break .if !eax
      invoke SendMessage,hw2,LB_ADDSTRING,0,addr buf
      inc edi
    .endw
    push 0
    push hw3
    push hw2
    push hw1
    .while TRUE
      pop ebx
    .break .if !ebx
      invoke GetClassLong,ebx,GCL_STYLE      ; WinXP needs it!
      mov edi,eax                            ; Win2k, Win7 - not need it...
      and eax,not CS_PARENTDC                ;
      invoke SetClassLong,ebx,GCL_STYLE,eax
      invoke SetLayeredWindowAttributes,ebx,0,220,LWA_ALPHA
      invoke SetClassLong,ebx,GCL_STYLE,edi  ;
      invoke SetWindowLong,ebx,GWL_WNDPROC,offset SubClass
      invoke SetWindowLong,ebx,GWL_USERDATA,eax
      invoke SetWindowPos,ebx,0,0,0,0,0,SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED or SWP_SHOWWINDOW
    .endw
    invoke LoadCursor,0,32649
    invoke SetClassLong,hw1,GCL_HCURSOR,eax
    invoke SetTimer,hWnd,2,3000,0
    invoke SetTimer,hWnd,1,100,0
    invoke Beep,4000,200 

  .else
    xor eax,eax
    ret
  .endif
  xor eax,eax
  inc eax
  ret
DlgProc endp

;-----------------------------------------------------------------------

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke DialogBoxParam,eax,1,0,offset DlgProc,0
  invoke ExitProcess,eax
end start

;-----------------------------------------------------------------------
